
//-------   --------------------------------------------------------------
extern double TakeProfit = 500;
extern double Lots = 0.1;
extern double Stoploss = 30;
extern double TrailingStop = 30;
extern string Indicator_1 = "SAR (SAR_STEP)";
extern double SAR_Step =0.02;
extern double SAR_MaxStep =0.2;
extern double GeneralShift = 0; // 0 -  , 1 - .

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start(){
	double a;
	int b;
	int total, ticket, cnt;
	//      
	if(Bars<100){
		Print("bars less than 100");
		return(0);
	}

	//   ,       100    ,
	//  .   ,      
	//  
	if(TakeProfit<5){
		Print("TakeProfit less than 5");
		return(0);
	}
	/*     - (   ,
		    .   ,  , 
		          
		.    ,    ,   
		   .   .
	*/

	total=OrdersTotal();
	if(total<1){
		/*     ,       .  
			 , , ,    ,     
			,        ,     .
			,     ,  
			.   ,       
			  <
			no opened orders identified
		*/
		if(AccountFreeMargin()<(1000*Lots)){
			Print("We have no money. Free Margin = ", AccountFreeMargin());
			return(0);
		}
	
	
	//     .     , 
	//  .    ,   
	//   ,       .

	if(iSAR(NULL,0,SAR_Step,SAR_MaxStep,GeneralShift)>Close[0]){// Open BUY
		// ,     .   ,  
		// ,    .
		ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-Stoploss*Point, Ask+TakeProfit*Point,"comment",16384,0,Green);
		/*   .  ,     ,   
			,     .  ,   
			(OP_BUY)   ( ,     ),
			  Lots (   ).   , 
			 3,   -  -,  
			,     "comment",    0,  
			 ,  ,      
		*/

	// 16384
	if(ticket>0){
		if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)){
			Print("BUY order opened : ",OrderOpenPrice());
		}
	}
	else{
		Print("Error opening BUY order : ",GetLastError());
		return(0);
	}
	/*      ,    ,    .
		,   ,  , -  -  .
		      .  YYYYYYYY - 
	*/
	if(iSAR(NULL,0,SAR_Step,SAR_MaxStep,GeneralShift)<Close[0]){
		ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+Stoploss*Point,Bid-TakeProfit*Point,"macd sample",16384,0,Red);
		if(ticket>0){
			if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)){
				Print("SELL order opened : ",OrderOpenPrice());
			}
		}
		else{
			Print("Error opening SELL order : ",GetLastError());
			return(0);
		}
	}
	
	//   .     ,  RRRRRRR - 

	//    BUY, ZZZZZZZZ -  SELL



	for(cnt=0;cnt

	//  for'a    

	{

	OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

	if(OrderType()<=OP_SELL && // check for opened position

	OrderSymbol()==Symbol()) // check for symbol

	{

	if(OrderType()==OP_BUY) // long position is opened

	{

	// should it be closed?

	if(iSAR(NULL,0,SAR_Step,SAR_MaxStep,GeneralShift)<Close[0]) //cloze BUY.

	{

	OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position

	return(0); // exit

	}

	// check for trailing stop

	if(TrailingStop>0)

	{

	if(Bid-OrderOpenPrice()>Point*TrailingStop)

	{

	if(OrderStopLoss()<Bid-Point*TrailingStop)

	{

	OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);

	return(0);

	}

	}

	}

	}

	else //     

	{

	// should it be closed?

	if(iSAR(NULL,0,SAR_Step,SAR_MaxStep,GeneralShift)>Close[0])//cloze SELL

	{

	OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position

	return(0); // exit

	}

	// check for trailing stop

	if(TrailingStop>0)

	{

	if((OrderOpenPrice()-Ask)>(Point*TrailingStop))

	{

	if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))

	{

	OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);

	return(0);

	}

	}

	}

	}

	}

	}

	}

	return(0);

	//--------

	}

	//-------- the end.